#ifndef AS_H
#define AS_H

#include <vector> //list of GUID
#include "common.h"

using namespace std;


//**********************************************************

class AutoSystem
{
public:
	
	AutoSystem(asNum ID);  //constructor
	AutoSystem(asNum ID, double lat, double lon); //constructor with AS's location
	//~AutoSystem();
	
	//************MEMBERS***************
	asNum asID; 
	Location_t as_location;  
	u32b packet_counter; //Number of message passed through the AS
	u64b local_clock;    //logical local clock 
	vector<AS_Prefix_entry_t> as_pref_vt; //list of prefix belong to this AS

	//***********OPERATIONS*************
	bool blind_GUID_lookup(u64b GUID,u32b &prefIndx,u32b &GUIDindx);
	bool GUID_lookup_with_prefIndx(u64b GUID,u32b prefIndx,u32b &GUIDindx);
	//void add_GUID_entryWithoutPrefixIdx(u64 GUID,u64b timeStamp);   //Doesn't require Index of Prefix 
	void add_GUID_entry(u64b GUID, u32b prefInx, u64b timeStamp);  //requires Index of Prefix 
	bool prefix_lookup(Cidr _prefix,u32b &returnIndex); 
	void addPrefix(Cidr _prefix);			// for prefix table updating 
	void shrinkPrefix(u32b prefIndex, Cidr newPref);
	

	void update_local_clock(u64b messageTStamp);
	
};

#endif // AS_H